/* DAC variables & libraries */
#include <Wire.h>
#include "Adafruit_MCP4725.h"

// moteur gauche
#define avanceG   48
#define arriereG  46

// mouteur droit
#define avanceD   47
#define arriereD  49

/* Define Variateur */
#define VAL_MAX_VAR 700
#define VAL_MIN_VAR 105

/* Variable globale */
Adafruit_MCP4725 dac_motorD;
Adafruit_MCP4725 dac_motorG;


void setup() {

  Serial.begin(115200);

  pinMode(avanceG , OUTPUT);
  pinMode(arriereG , OUTPUT);
  digitalWrite(avanceG, LOW);
  digitalWrite(arriereG, LOW);

  pinMode(avanceD , OUTPUT);
  pinMode(arriereD , OUTPUT);
  digitalWrite(avanceD, LOW);
  digitalWrite(arriereD, LOW);

  dac_motorD.begin(0x62);
  dac_motorD.setVoltage(VAL_MIN_VAR, true);

  dac_motorG.begin(0x63);
  dac_motorG.setVoltage(VAL_MIN_VAR, true);
  delay(5000);
}

void loop() {

  activation_moteur(1, 1); // activation moteur gauche 
  setVitesseMot( 0,  60); // lancer moteur gauche meme vitesse

  activation_moteur(1, 1); // activation moteur droit 
  setVitesseMot( 1,  60); // lancer moteur droit meme vitesse

}

void activation_moteur(int motD, int motG) {
  switch (motD) {
    case 0: digitalWrite(avanceD, LOW);
      digitalWrite(arriereD, HIGH);
      break;
    case 1: digitalWrite(arriereD, LOW);
      digitalWrite(avanceD, HIGH);
      break;
    default: digitalWrite(avanceD, LOW);
      digitalWrite(arriereD, LOW);
      break;
  }
  switch (motG) {
    case 0: digitalWrite(avanceG, LOW);
      digitalWrite(arriereG, HIGH);
      break;
    case 1: digitalWrite(arriereG, LOW);
      digitalWrite(avanceG, HIGH);
      break;
    default: digitalWrite(avanceG, LOW);
      digitalWrite(arriereG, LOW);
      break;
  }
}
void setVitesseMot(int mot, int vitprc)
{
  int vitesse;
  vitesse = (vitprc * ((VAL_MAX_VAR - VAL_MIN_VAR) / 100)) + VAL_MIN_VAR;
  if (vitesse > VAL_MAX_VAR) vitesse = VAL_MAX_VAR;
  if (vitesse < VAL_MIN_VAR) vitesse = VAL_MIN_VAR;
  if (mot == 1) dac_motorG.setVoltage(vitesse, true);
  if (mot == 0) dac_motorD.setVoltage(vitesse, true);
}
